package org.jboss.soa.modeshape.qa.tests.performance;

import java.util.Random;

import javax.jcr.Node;
import javax.jcr.Session;

import org.jboss.soa.esb.qa.framework.Timer;
import org.testng.annotations.Test;

@Test(groups = "performance")
public class ComplexPerformanceTest extends AbstractPerformanceTest {

	@Test
	public void complexPerfromance() throws Exception {
		Timer writeTimer = new Timer();

		// Create a big strings to be stored
		String[] bigData = new String[100];
		Random rnd = new Random();
		for (int i = 0; i < bigData.length; i++) {
			StringBuilder sb = new StringBuilder();
			for (int j = 0; j < 1000; j++) {
				sb.append(rnd.nextInt(1000));				
			}
			bigData[i] = sb.toString();
		}

		Node root = writeSession.getRootNode();
		Node last = root;
		int order = 0;
		for (int batchNo = 1; batchNo <= (testCount / batchSize); batchNo++) {
			writeTimer.reset();
			for (int j = 0; j < batchSize; j++) {
				last = root.addNode("perf" + ++order, "nt:unstructured");				
				// Add children
				for (int i = 1; i <= 5; i++) {
					last = last.addNode("child" + i, "nt:unstructured");
				}
				// Add properties
				for (int i = 1; i <= 4; i++) {
					last.setProperty("prop" + i, "This is property no " + i);
				}
				last.setProperty("bigProperty", bigData[rnd.nextInt(bigData.length)]);
			}
			writeSession.save();
			long writeTime = writeTimer.elapsed();
			String lastName = last.getPath();
			Timer readTimer = new Timer();
			Session readSession = getSession();
			readTimer.reset();
			Node n = readSession.getNode(lastName);
			n.getProperty("bigProperty");
			long readTime = readTimer.elapsed();
			readSession.logout();
			logResults(batchNo, writeTime, readTime);
		}
	}
}
