package org.jboss.soa.modeshape.qa.tests.performance;

import javax.jcr.Node;

import org.jboss.soa.esb.qa.framework.Timer;
import org.testng.annotations.Test;

@Test(groups = "performance")
public class DepthOnlyPerformanceTest extends AbstractPerformanceTest {

	@Test
	public void depthOnlyPerfromance() throws Exception {
		Timer writeTimer = new Timer();

		testCount = 200; // too slow, make it shorter
		Node root = writeSession.getRootNode();
		Node last = root;
		int order = 0;
		for (int batchNo = 1; batchNo <= (testCount / batchSize); batchNo++) {
			writeTimer.reset();
			for (int j = 0; j < batchSize; j++) {
				last = last.addNode("perf" + ++order, "nt:unstructured");				
			}
			writeSession.save();
			long writeTime = writeTimer.elapsed();
			String lastName = last.getPath();
			long readTime = readNode(lastName);
			logResults(batchNo, writeTime, readTime);
		}
	}

}
