package org.jboss.soa.modeshape.qa.tests.performance;

import javax.jcr.Node;
import javax.jcr.Session;

import org.jboss.soa.esb.qa.framework.Timer;
import org.testng.annotations.Test;

@Test(groups = "performance")
public class PropertyOnlyPerformanceTest extends AbstractPerformanceTest {

	@Test
	public void propertyOnlyPerfromance() throws Exception {
		Timer writeTimer = new Timer();

		Node root = writeSession.getRootNode();
		Node last = root.addNode("main");
		int order = 0;
		String lastPropertyName = null;
		for (int batchNo = 1; batchNo <= (testCount / batchSize); batchNo++) {
			writeTimer.reset();
			for (int j = 0; j < batchSize; j++) {
				lastPropertyName = "prop" + ++order;
				last.setProperty(lastPropertyName, "This is property");				
			}
			writeSession.save();
			long writeTime = writeTimer.elapsed();
			String lastName = last.getPath();
			Timer readTimer = new Timer();
			Session readSession = getSession();
			readTimer.reset();
			Node n = readSession.getNode(lastName);
			n.getProperty(lastPropertyName);
			long readTime = readTimer.elapsed();
			readSession.logout();
			logResults(batchNo, writeTime, readTime);
		}
	}

}
